VERSION 5.00
Begin VB.Form FMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "LVTransparentIcons"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3585
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   3585
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdChangeFgColor 
      Caption         =   "&Vordergrundfarbe ndern"
      Height          =   375
      Left            =   525
      TabIndex        =   0
      Top             =   480
      Width           =   2535
   End
   Begin VB.CommandButton cmdMakeBkTransp 
      Caption         =   "Hi&ntergrund transparent"
      Height          =   375
      Left            =   525
      TabIndex        =   2
      Top             =   1440
      Width           =   2535
   End
   Begin VB.CommandButton cmdChangeBkColor 
      Caption         =   "&Hintergrundfarbe ndern"
      Height          =   375
      Left            =   525
      TabIndex        =   1
      Top             =   960
      Width           =   2535
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function FindWindowEx Lib "user32.dll" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetSysColor Lib "user32.dll" (ByVal nIndex As Integer) As Long
Private Declare Function InvalidateRect Lib "user32.dll" (ByVal hWnd As Long, ByRef lpRect As Any, ByVal bErase As Long) As Long
Private Declare Function UpdateWindow Lib "user32.dll" (ByVal hWnd As Long) As Long

' ListView messages.
Private Const LVM_FIRST As Long = &H1000&
Private Const LVM_GETTEXTCOLOR As Long = (LVM_FIRST + 35&)
Private Const LVM_SETTEXTCOLOR As Long = (LVM_FIRST + 36&)
Private Const LVM_GETTEXTBKCOLOR As Long = (LVM_FIRST + 37&)
Private Const LVM_SETTEXTBKCOLOR As Long = (LVM_FIRST + 38&)

' Transparent, "no color".
Private Const CLR_NONE As Long = &HFFFFFFFF

' Original colors.
Private m_OldBkColor As Long
Private m_OldFgColor As Long

Private Sub cmdChangeBkColor_Click()
    Call ListViewSetTextBkColor(GetProgmanLVhWnd, QBColor(Rnd * 15))
End Sub

Private Sub cmdChangeFgColor_Click()
    Call ListViewSetTextFgColor(GetProgmanLVhWnd, QBColor(Rnd * 15))
End Sub

Private Sub cmdMakeBkTransp_Click()
    Call ListViewSetTextBkColor(GetProgmanLVhWnd, CLR_NONE)
End Sub

Private Sub Form_Load()
    Call Randomize
    m_OldBkColor = ListViewGetTextBkColor(GetProgmanLVhWnd)
    m_OldFgColor = ListViewGetTextFgColor(GetProgmanLVhWnd)
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    ' Reset colors.
    Call ListViewSetTextBkColor(GetProgmanLVhWnd, m_OldBkColor)
    Call ListViewSetTextFgColor(GetProgmanLVhWnd, m_OldFgColor)
End Sub

'***********************************
' ListView Routines.
'***********************************

' Updates the listview's client area.
Private Sub UpdateListView(ByVal hWnd As Long)

    ' Add a rectangle to the listview's update region. This is the portion
    ' of the window's client area that must be redrawn. The 0 parameter
    ' tells it to redraw the entire client area.
    Call InvalidateRect(hWnd, ByVal 0&, 1&)
    
    ' Send a 'WM_PAINT' message to the listview to force it to redraw itself.
    Call UpdateWindow(hWnd)
End Sub

' Sets the listview item's foreground color.  The return value gives
' information about the success of the operation, 'NULL' means success.
Private Function ListViewSetTextFgColor(ByVal hWnd As Long, ByVal NewColor As Long) As Long
    ListViewSetTextFgColor = SendMessage(hWnd, LVM_SETTEXTCOLOR, 0&, NewColor)
    Call UpdateListView(hWnd)
End Function

' Gets the listview item's foreground color.
Private Function ListViewGetTextFgColor(ByVal hWnd As Long) As Long
    ListViewGetTextFgColor = SendMessage(hWnd, LVM_GETTEXTCOLOR, 0&, 0&)
End Function

' Sets the listview items' background color.
Private Function ListViewSetTextBkColor(ByVal hWnd As Long, ByVal NewColor As Long) As Long
    ListViewSetTextBkColor = SendMessage(hWnd, LVM_SETTEXTBKCOLOR, 0&, NewColor)
    Call UpdateListView(hWnd)
End Function

' Gets the listview items' background color.
Private Function ListViewGetTextBkColor(ByVal hWnd As Long) As Long
    ListViewGetTextBkColor = SendMessage(hWnd, LVM_GETTEXTBKCOLOR, 0&, 0&)
End Function

' Gets the handle to the listview control on the desktop.
Private Function GetProgmanLVhWnd() As Long
    Dim hWndProgman As Long
    Dim hWndSHELLDLLDefView As Long
    Dim hWndSysListView32 As Long
    hWndProgman = FindWindow("Progman", "Program Manager")
    If hWndProgman = 0 Then
        Exit Function
    End If
    hWndSHELLDLLDefView = FindWindowEx(hWndProgman, 0&, "SHELLDLL_DefView", vbNullString)
    If hWndSHELLDLLDefView = 0 Then
        Exit Function
    End If
    hWndSysListView32 = FindWindowEx(hWndSHELLDLLDefView, 0&, "SysListView32", vbNullString)
    GetProgmanLVhWnd = hWndSysListView32
End Function
